ASTTransformation (Groovy 2.4.3)
Date: 2015-03-23

org.codehaus.groovy.transform

## Interface ASTTransformation

- All Known Implementing Classes:
    AbstractASTTransformation, AbstractInterruptibleASTTransformation, AstBuilderTransformation, AutoCloneASTTransformation, BaseScriptASTTransformation, BindableASTTransformation, BuilderASTTransformation, CanonicalASTTransformation, CategoryASTTransformation, DelegateASTTransformation, EqualsAndHashCodeASTTransformation, ExternalizeMethodsASTTransformation, ExternalizeVerifierASTTransformation, FieldASTTransformation, GrabAnnotationTransformation, ImmutableASTTransformation, IndexedPropertyASTTransformation, InheritConstructorsASTTransformation, LazyASTTransformation, LogASTTransformation, MemoizedASTTransformation, MixinASTTransformation, NewifyASTTransformation, NotYetImplementedASTTransformation, PackageScopeASTTransformation, ReadWriteLockASTTransformation, SingletonASTTransformation, SortableASTTransformation, SourceURIASTTransformation, StaticCompileTransformation, StaticTypesTransformation, SynchronizedASTTransformation, ToStringASTTransformation, TraitASTTransformation, TupleConstructorASTTransformation, VetoableASTTransformation

      public interface ASTTransformation

  This class is instantiated and invoked when an AST transformation is activated. For Global AST Transformations, this interface is called once per SourceUnit, which is usually a Groovy source file. For Local AST Transformations, this interface is invoked once every time the Local annotation marker is encountered.

  You must annotate this class with `GroovyASTTransformation` so that Groovy knows which `CompilePhase` to run in.

  Author:
    Danno Ferrin (shemnon)
  See Also:
    `GroovyASTTransformation`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `visit(ASTNode[] nodes, SourceUnit source)` The method is invoked when an AST Transformation is active.

- - ### Method Detail

    - #### visit

          void visit(ASTNode[] nodes,
                   SourceUnit source)

      The method is invoked when an AST Transformation is active. For local transformations, it is invoked once each time the local annotation is encountered. For global transformations, it is invoked once for every source unit, which is typically a source file.
      Parameters:
        `nodes` - The ASTnodes when the call was triggered. Element 0 is the AnnotationNode that triggered this annotation to be activated. Element 1 is the AnnotatedNode decorated, such as a MethodNode or ClassNode. For global transformations it is usually safe to ignore this parameter.
        `source` - The source unit being compiled. The source unit may contain several classes. For global transformations, information about the AST can be retrieved from this object.